package implement

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/dao"
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/models"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_model.git/utils/logx"
	"xorm.io/xorm"
)

func NewSuperCloudIssuanceUserRobotBindFollowUserDb(engine *xorm.Engine) dao.SuperCloudIssuanceUserRobotBindFollowUserDao {
	return &SuperCloudIssuanceUserRobotBindFollowUserDb{Db: engine}
}

type SuperCloudIssuanceUserRobotBindFollowUserDb struct {
	Db *xorm.Engine
}

func (s SuperCloudIssuanceUserRobotBindFollowUserDb) GetCloudIssuanceUserRobotBindFollowUser(id int) (m *models.SuperCloudIssuanceUserRobotBindFollowUser, err error) {
	m = new(models.SuperCloudIssuanceUserRobotBindFollowUser)
	has, err := s.Db.Where("id =?", id).Get(m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (s SuperCloudIssuanceUserRobotBindFollowUserDb) GetCloudIssuanceUserRobotBindFollowUserByWxId(wxId string) (m *models.SuperCloudIssuanceUserRobotBindFollowUser, err error) {
	m = new(models.SuperCloudIssuanceUserRobotBindFollowUser)
	has, err := s.Db.Where("monitor_host_wx_id =?", wxId).Get(m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (s SuperCloudIssuanceUserRobotBindFollowUserDb) InsertCloudIssuanceUserRobotBindFollowUser(m *models.SuperCloudIssuanceUserRobotBindFollowUser) (id int, err error) {
	_, err = s.Db.InsertOne(m)
	if err != nil {
		return 0, err
	}
	id = m.Id
	return id, nil
}

func (s SuperCloudIssuanceUserRobotBindFollowUserDb) BatchAddCloudIssuanceUserRobotBindFollowUsers(data []*models.SuperCloudIssuanceUserRobotBindFollowUser) (int64, error) {
	affected, err := s.Db.Insert(data)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func (s SuperCloudIssuanceUserRobotBindFollowUserDb) SaveCloudIssuanceUserRobotBindFollowUser(id interface{}, m *models.SuperCloudIssuanceUserRobotBindFollowUser, forceColums ...string) (affected int64, err error) {
	if forceColums != nil {
		affected, err = s.Db.Where("id=?", id).Cols(forceColums...).Update(m)
	} else {
		affected, err = s.Db.Where("id=?", id).Update(m)
	}
	return
}

func (s SuperCloudIssuanceUserRobotBindFollowUserDb) DeleteCloudIssuanceUserRobotBindFollowUser(bindId interface{}) (affected int64, err error) {
	_, err = s.Db.Where("bind_id=?", bindId).Delete(models.SuperCloudIssuanceUserRobotBindFollowUser{})
	if err != nil {
		return 0, err
	}
	return 1, nil
}
